// 011 u_test_u_c_basic_object
// 01 jan 2002

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_test_u_c_basic_object;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses u_c_display
     , u_c_basic_object
     ;

    {$R *.DFM}

  
    const k_log_path= 'log\';
          k_log_name= 'log_c_basic_object.txt';

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_display_log(k_log_path+ k_log_name);
      end; // FormCreate

    procedure TForm1.Button1Click(Sender: TObject);
      begin
        with c_basic_object.create_basic_object('base') do
        begin
          display(m_name);
          Free;
        end; // with c_basic_object
      end;

    type c_my_object= Class(c_basic_object)
                        m_value: Integer;
                        Constructor create_my_object(p_name: String; p_value: Integer); Virtual;
                        function f_display_my_object: String;
                      end;

    Constructor c_my_object.create_my_object(p_name: String; p_value: Integer);
      begin
        Inherited create_basic_object(p_name);
        m_value:= p_value;
      end; // create_my_object

    function c_my_object.f_display_my_object: String;
      begin
        Result:= m_name+ ' '+ IntToStr(m_value);
      end; // f_display_my_object  

    procedure TForm1.Button2Click(Sender: TObject);
      begin
        with c_my_object.create_my_object('my_object', 3) do
        begin
          display(f_display_my_object);
        end;
      end;

end.
